pragma solidity ^0.6.0;
// SPDX-License-Identifier: MIT


interface zkAsset {
    
    function transferFrom(address sender, address recipient, uint256 amount) external returns (bool);
    function transfer(address recipient, uint256 amount) external returns (bool);
    function allowance(address owner, address spender) external view returns (uint256);
    function mint(address to, uint256 amount) external;
    function burn(address to, uint256 amount) external;
    
    event Transfer(address indexed from, address indexed to, uint256 value);
    
}

interface chainLink {
    function getPrice() external view returns (uint256);
}

contract burner {
    zkAsset tokenA;
    zkAsset tokenB;
    chainLink priceOracle;
    
    event Shifted(uint256 value);
    
    constructor(address _tokenA, address _tokenB) public{
        tokenA = zkAsset(_tokenA);
        tokenB = zkAsset(_tokenB);
        priceOracle = chainLink(); // deployed chainlink.sol address
    }
    
    function shift(uint256 amount) public {
        require(amount > 0, "amount can't be zero");
        uint256 allowance = tokenA.allowance(msg.sender, address(this));
        uint256 Price = priceOracle.getPrice();
        require(allowance >= amount, "remember to approve this contract");
        tokenA.transferFrom(msg.sender, address(0x5a6b6173736574), amount);// <--- burn here
        tokenB.mint(msg.sender ,((amount * Price)/10**18);//mint
        emit Shifted(amount);
    }  
}
