const StakingRewards = artifacts.require('StakingRewards');


const XFT_TOKEN_ADDRESS = '0xabe580e7ee158da464b51ee1a83ac0289622e6be'.toLowerCase();
const SUSHI_TOKEN_ADDRESS = '0x6b3595068778dd592e39a122f4f5a5cf09c90fe2'.toLowerCase();
const SLP_TOKEN_ADDRESS = '0xF39fF863730268C9bb867b3a69d031d1C1614b31'.toLowerCase();

const MASTER_CHEF_ADDRESS = '0xc2EdaD668740f1aA35E4D8f227fB8E17dcA888Cd'.toLowerCase();

const PID = '149'; // ! BEFORE MIGRATE: make sure that you set up correct PID

module.exports = async (deployer, network, accounts) => {
  await deployer.deploy(
    StakingRewards,
    XFT_TOKEN_ADDRESS,
    SUSHI_TOKEN_ADDRESS,
    SLP_TOKEN_ADDRESS,
    MASTER_CHEF_ADDRESS,
    PID,
  );
  const staking = await StakingRewards.deployed();

  // await xft.transfer(staking.address, ALLOCATE_POINT_XFT);
  // await staking.notifyRewardAmount(ALLOCATE_POINT_XFT);

  console.log(`XFT Token: https://etherscan.io/address/${XFT_TOKEN_ADDRESS}`);
  console.log(`SUSHI Token: https://etherscan.io/address/${SUSHI_TOKEN_ADDRESS}`);
  console.log(`XFT/ETH SLP Token: https://etherscan.io/address/${SLP_TOKEN_ADDRESS}`);
  console.log(`Staking contract: https://etherscan.io/address/${staking.address}`);
  console.log(`MasterChef contract: https://etherscan.io/address/${MASTER_CHEF_ADDRESS}`);
  console.log('Address owner: ', accounts[0]);
};
