import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import {LoginComponent} from './pages/login/login.component';
import {AuthGuard} from './core/guards/auth/auth.guard';
import {FormComponent} from './pages/form/form.component';

export const routes: Routes = [
  {
    path: 'login',
    component: LoginComponent,
  },
  {
    path: 'stake-now',
    component: FormComponent,
    canActivate: [
      AuthGuard,
    ],
  },
  {
    path: ' ',
    redirectTo: '/stake-now',
    pathMatch: 'full'
  },
  {
    path: '**',
    redirectTo: '/stake-now',
  }
];

@NgModule({
  imports: [
    RouterModule.forRoot(
      routes,
      {
        onSameUrlNavigation: 'reload'
      }
    )
  ],
  exports: [RouterModule]
})
export class AppRoutingModule { }
