import {Injectable} from '@angular/core';
import {CanActivate, Router, RouterStateSnapshot, ActivatedRouteSnapshot} from '@angular/router';
import {action} from 'mobx-angular';
import {AuthService} from '../../services/auth/auth.service';

@Injectable({ providedIn: 'root' })
export class AuthGuard implements CanActivate {
  constructor(
      private router: Router,
      private authenticationService: AuthService
  ) { }

  @action canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot) {
    if (!this.authenticationService.isLogged) {
      this.router.navigate(['/login']);
      return false;
    }
    return true;
  }
}
